"{ Encoding: utf8 }" !
!Tools::OrganizerCanvas methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    |orgMode trigger classes selectedClassesHolder selectionValue|

    orgMode := organizerMode value.
    selectedClassesHolder := self selectedClasses.
    classes := selectedClassesHolder value copy ? #().

    changedObject == packageFilter ifTrue:[
        self breakPoint:#cg
    ].

    changedObject == organizerMode ifTrue:[
        self classHierarchyListSlaveMode value:true.
        self classInheritanceListSlaveMode value:true.
        self classListSlaveMode value:true.
        self categoryListSlaveMode value:true.
        self nameSpaceListSlaveMode value:true.
        self projectListSlaveMode value:true.

        self variableFilter value:nil.
        self packageFilter value:nil.
        self nameSpaceFilter value:nil.

        "/ must update the packageFilter
        orgMode == OrganizerCanvas organizerModeProject ifTrue:[
            self selectedProjects value:(classes collect:[:each | each package] as:Set).
            packageFilter setValue:(self selectedProjects value)
        ] ifFalse:[
            packageFilter value:nil
        ].

        self updateOrganizationFromChangedClass.

        orgMode == OrganizerCanvas organizerModeCategory ifTrue:[
            trigger := self forceClassCategoryGeneratorTrigger.
        ] ifFalse:[ orgMode == OrganizerCanvas organizerModeHierarchy ifTrue:[
            trigger := self forceClassHierarchyGeneratorTrigger.
        ] ifFalse:[ orgMode == OrganizerCanvas organizerModeNamespace ifTrue:[
            trigger := self forceNamespaceGeneratorTrigger
        ] ifFalse:[ orgMode == OrganizerCanvas organizerModeProject ifTrue:[
            trigger := self forceProjectGeneratorTrigger.
        ] ifFalse:[ ((orgMode == OrganizerCanvas organizerModeClassHierarchy) 
                  or:[orgMode == OrganizerCanvas organizerModeClassInheritance]) ifTrue:[
"/            trigger := self forceClassHierarchyGeneratorTrigger.
        ]]]]].

        trigger notNil ifTrue:[
            trigger value:true
        ].
        "/ selectedClassesHolder value:classes.

        (orgMode == OrganizerCanvas organizerModeClassHierarchy or:[orgMode == OrganizerCanvas organizerModeHierarchy]) ifTrue:[
            classHierarchyListSlaveMode value:false.
        ].
        (orgMode == OrganizerCanvas organizerModeClassInheritance) ifTrue:[
            classInheritanceListSlaveMode value:false.
        ].
        (orgMode == OrganizerCanvas organizerModeClassInheritance 
        or:[orgMode == OrganizerCanvas organizerModeClassHierarchy 
        or:[orgMode == OrganizerCanvas organizerModeHierarchy]])
        ifFalse:[
            classListSlaveMode value:false.
        ].
        (orgMode == OrganizerCanvas organizerModeCategory) ifTrue:[
            categoryListSlaveMode value:false.
        ].
        (orgMode == OrganizerCanvas organizerModeNamespace) ifTrue:[
            namespaceListSlaveMode value:false.
        ].
        (orgMode == OrganizerCanvas organizerModeProject) ifTrue:[
            projectListSlaveMode value:false.
            self selectedProjects value isEmptyOrNil ifTrue:[
                self updateProjectSelectionFromClasses.
            ].
        ].
        (orgMode == OrganizerCanvas organizerModePackageDiagram) ifTrue:[
            "/
            self selectedProjects value isEmptyOrNil ifTrue:[
                self updateProjectSelectionFromClasses.
            ].
        ].

        ^ self
    ].

    changedObject == selectedClasses ifTrue:[
        selectedClasses value size ~~ 0 ifTrue:[
            (orgMode ~~ OrganizerCanvas organizerModeClassHierarchy
            and:[ orgMode ~~ OrganizerCanvas organizerModePackageDiagram ]) ifTrue:[
                "/ if the organizerMode is project, avoid clobbering the project selection
                (orgMode ~~ OrganizerCanvas organizerModeProject
                "/ or:[ (self selectedProjects value includesAll:( selectedClasses value collect:[:each | each package] )) not ]
                or:[ (self selectedProjects value includes: self class nameListEntryForChanged)
                or:[ (self selectedProjects value includes: self class nameListEntryForALL) ]]
                ) ifTrue:[
                    self updateOrganizationFromChangedClass.
                ].
            ].
        ]
    ].
"/    changedObject == selectedNamespaces ifTrue:[
"/ self halt.
"/    ].
    changedObject == nameSpaceFilterSelection ifTrue:[
        selectionValue := nameSpaceFilterSelection value.
        selectionValue size > 1 ifTrue:[
            nameSpaceFilterSelection value:(OrderedCollection with:selectionValue first).
            selectionValue := nameSpaceFilterSelection value.
        ].
        self selectedNamespaces value:selectionValue.
        selectionValue size > 0 ifTrue:[
            self nameSpaceFilterSelectedNameSpace setValue:selectionValue first.
            self updateNameSpaceLabel.
        ].
        self nameSpaceFilter value: selectionValue.
    ].
    changedObject == self selectedProjects ifTrue:[
        self breakPoint:#cg.
        self selectedProjectsChanged.
    ].
    changedObject == self selectedDiagramProject ifTrue:[
        self breakPoint:#cg.
        self selectedProjects value:(Array with:self selectedDiagramProject value).
        self selectedProjectsChanged.
        ^ self
    ].

    super update:something with:aParameter from:changedObject

    "Modified: / 27-04-2010 / 16:58:31 / cg"
    "Modified: / 26-03-2014 / 10:17:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

